#===============================================================================
# Copyright 2014-2017 Intel Corporation All Rights Reserved.
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#===============================================================================

## <a name="DAAL-EXAMPLE-PY-LOW_ORDER_MOMENTS_DENSE_DISTRIBUTED"></a>
## \example low_order_moms_dense_distr.py

from os import environ
from os.path import join as jp

from daal.algorithms.low_order_moments import (
    Distributed_Step1LocalFloat64DefaultDense,
    Distributed_Step2MasterFloat64DefaultDense, data, partialResults, minimum,
    maximum, sum, sumSquares, sumSquaresCentered, mean, secondOrderRawMoment,
    variance, standardDeviation, variation
)
from daal.data_management import FileDataSource, DataSourceIface

import inspect, sys, os.path
utils_folder = os.path.realpath(os.path.abspath(jp(os.path.split(inspect.getfile(inspect.currentframe()))[0], "..")))
if utils_folder not in sys.path:
    sys.path.insert(0, utils_folder)
from utils import printNumericTable

DAAL_PREFIX = jp('..', 'data')

# Input data set parameters
nBlocks = 4

datasetFileNames = [
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_dense_1.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_dense_2.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_dense_3.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_dense_4.csv')
]

partialResult = [0] * nBlocks
result = None


def computestep1Local(block):
    global partialResult

    # Initialize FileDataSource<CSVFeatureManager> to retrieve the input data from a .csv file
    dataSource = FileDataSource(
        datasetFileNames[block], DataSourceIface.doAllocateNumericTable,
        DataSourceIface.doDictionaryFromContext
    )

    # Retrieve the data from the input file
    dataSource.loadDataBlock()

    # Create algorithm objects to compute low order moments in the distributed processing mode using the default method
    algorithm = Distributed_Step1LocalFloat64DefaultDense()

    # Set input objects for the algorithm
    algorithm.input.set(data, dataSource.getNumericTable())

    # Compute partial low order moments estimates on nodes
    partialResult[block] = algorithm.compute()  # Get the computed partial estimates


def computeOnMasterNode():
    global result

    # Create algorithm objects to compute low order moments in the distributed processing mode using the default method
    algorithm = Distributed_Step2MasterFloat64DefaultDense()

    # Set input objects for the algorithm
    for i in range(nBlocks):
        algorithm.input.add(partialResults, partialResult[i])

    # Compute a partial low order moments estimate on the master node from the partial estimates on local nodes
    algorithm.compute()

    # Finalize the result in the distributed processing mode
    result = algorithm.finalizeCompute() # Get the computed low order moments


def printResults(res):

    printNumericTable(res.get(minimum),              "Minimum:")
    printNumericTable(res.get(maximum),              "Maximum:")
    printNumericTable(res.get(sum),                  "Sum:")
    printNumericTable(res.get(sumSquares),           "Sum of squares:")
    printNumericTable(res.get(sumSquaresCentered),   "Sum of squared difference from the means:")
    printNumericTable(res.get(mean),                 "Mean:")
    printNumericTable(res.get(secondOrderRawMoment), "Second order raw moment:")
    printNumericTable(res.get(variance),             "Variance:")
    printNumericTable(res.get(standardDeviation),    "Standard deviation:")
    printNumericTable(res.get(variation),            "Variation:")

if __name__ == "__main__":

    for i in range(nBlocks):
        computestep1Local(i)

    computeOnMasterNode()
    printResults(result)
